

class LogonUI {

	LABEL_CTL="labelControls";
	CHBXLOGGINCONTROL="div#controlsTable > input#ckshowLogonControls";
 	STORAGE_CHK="chckbxLoginControls";
 	ELEM_TO_HIDE='loginDivInnerTable';

	_chckboxLogginControl;
	_test;
	_docHTML;
	_localSt;

	constructor( win)
	{
	
		this._docHTML=win.document;
		this._localSt=win.localStorage;
		this._chckboxLogginControl = this._docHTML.querySelector(this.CHBXLOGGINCONTROL); 
		this._test="a";

		this._docHTML.addEventListener("DOMContentLoaded", () => {// detecting when load DOM
			
			let enableBtns = this.IsVizorAuthEnabled();
			if(!this._localSt.getItem(this.STORAGE_CHK)){
				
				this.SetValueToLStorage(false);
				if(!enableBtns && enableBtns !== undefined ){
					this.EnableCheckBox();
				}				
				
			}
			
			else{
				
				let checkbxVal= this._localSt.getItem(this.STORAGE_CHK);
				if(checkbxVal=="true"){
					this._chckboxLogginControl.checked=true;
					this.ShowFieldsLoginCtrl();
				}else{
					this._chckboxLogginControl.checked=false;
					
				}
				
			}
			
	
		});

		


	}

	// * Function to enable or disable the logon check box in case there is no type of additional authentication, such as: Google, Azure or the Network button.
	IsVizorAuthEnabled(){
	
		let mainLogonButtons =this._docHTML.querySelector(".extraLoginButtonsTable");
		let networkContainerButtons = this._docHTML.getElementById("a_networkAcct");
		let blnFoundButtons;
		let btnNetwork;
		let blnLoadContainerButtons = false;
		

		mainLogonButtons.addEventListener("load", () => {
			
			let numberButtons = mainLogonButtons.querySelectorAll("tr.extraLoginButtons");
			let blnBtns;
		
			
			for (let button of numberButtons) {
				let td = button.querySelector("td");
				let div = td.querySelector("div");
			
				if (div && (div.id === "a_azureAcct" || div.id === "g_id_onload")) {
				
					blnFoundButtons = true; 
					let verifyChbxStatus = this._chckboxLogginControl.checked;
					
					if(verifyChbxStatus){
						this.DisableCheckBox();
					}
				}
			}

			if (blnFoundButtons) {
			blnBtns = true;
			return blnBtns;
			}
			

		},400);
		
		if(!blnLoadContainerButtons){
			if(networkContainerButtons){
				let blnBtns;
				btnNetwork = networkContainerButtons.querySelector("#btnActionnetworkAcct");

				if (btnNetwork) {
				blnBtns = true;
				return blnBtns;
				}
			}
			else{
			return false;//OR return var blnBtnsDefault = false;
			}
		}
		
		
		
	}
	
	

	EnableCheckBox(){
		
		this._chckboxLogginControl.click();
		this._chckboxLogginControl.checked = true;
	}
	DisableCheckBox(){
		
		this._chckboxLogginControl.click();
		this._chckboxLogginControl.checked = false;
	}



	// get
	ShowFieldsLoginCtrl()
	{
		
		this._docHTML.getElementById(this.ELEM_TO_HIDE).style.display="block";
	}

	HideFieldsLoginCtrl()
	{
		this._docHTML.getElementById(this.ELEM_TO_HIDE).style.display="none";
	}

	//set
	SetValueToLStorage(value)
	{
		this._localSt.setItem(this.STORAGE_CHK,value);
		
	}

	SetValueLStorageShowFlds(value)
	{		
		this.SetValueToLStorage(value);

		if (value)
		{
			this.ShowFieldsLoginCtrl();
		}
		else
		{
			this.HideFieldsLoginCtrl();
		}

	}

	ShowHideFromCheckBox() 
	{// click on checkbox
		
		if(this._chckboxLogginControl.checked){
						
			this.SetValueLStorageShowFlds(true);
			
		}
		else{
			this.SetValueLStorageShowFlds(false);
		}
		
	}

	OnClickLabel()
	{ // click on label
		
		// toggle the checkbox
		this._chckboxLogginControl.checked=!this._chckboxLogginControl.checked;

		// apply the rule
		this.ShowHideFromCheckBox();

	}	
	

}


// Dependencies: RESX

var personaArr = [[g_MqRef.RESX['SOFTWARE_MANAGER'], 'software-installation-big.png',
						g_MqRef.RESX['SOFTWARE_MANAGER_TOOLTIP'], 
						'dambler', '',''], 
						
						[g_MqRef.RESX['EMPLOYEE'], 'person-male.png', 
						g_MqRef.RESX['EMPLOYEE_TOOLTIP'], 
						'employee', '',''],
						
						[g_MqRef.RESX['IT_ASSET_MANAGER'], 'QLResourcesCatalog-big.png', 
						g_MqRef.RESX['IT_ASSET_MANAGER_TOOLTIP'], 
						'dnathan', '',''],
						
						[g_MqRef.RESX['IT_MANAGER'], 'manager.png', 
						g_MqRef.RESX['IT_MANAGER_TOOLTIP2'], 
						'itmanager', '',''],
						
						[g_MqRef.RESX['HELPDESK_ANALYST'], 'QLTechSupport.png',
						g_MqRef.RESX['HELPDESK_ANALYST_TOOLTIP'], 
						'analyst', '',''], 
						
						[g_MqRef.RESX['HR_MANAGER'], 'hr-manager.png',
						g_MqRef.RESX['HR_MANAGER_TOOLTIP'], 
						'mrosen', '',''], 
						
						/*[g_MqRef.RESX['RELEASE_MANAGER'], 'mrosen.jpg',
						g_MqRef.RESX['RELEASE_MANAGER_TOOLTIP'], 
						'chubbard', '',''], */
						
						[g_MqRef.RESX['VIZOR_ADMIN'], 'configuration-big.png', 
						g_MqRef.RESX['VIZOR_ADMIN_TOOLTIP'], 
						'admin', 'admin','']];

var blnCanChangeTheme=true;


function PersonaLogonsMgr(docHTML, personaArr, sInstanceName, callerRef)
{

	var _me=this;
		
	var PERSONA_NAME = 0;
	var PERSONA_IMAGE = 1;
	var PERSONA_TOOLTIP = 2;
	var PERSONA_USERNAME = 3;
	var PERSONA_PASS = 4;
	
	var m_docHTML=docHTML;
	var m_personaArr =personaArr ;
	var m_sInstanceName =sInstanceName;
	var m_callerRef=callerRef;
	
	function WriteMenu()
	{
		var loginScreen = m_docHTML.getElementById('loginScreen');
		var divEvalContent = m_docHTML.getElementById('EvalContent');
		
		var imgDir = "Theme/images/images/";
		var i;
		var x = 0;
		
		var evalHTML = "";
		
		if(loginScreen){
			loginScreen.style.top = '38%';
		}
			
		evalHTML += g_MqRef.RESX['EVAL_INSTRUCTION'];
		
								
		evalHTML += '<center><table id="personas" cellspacing="0" cellpadding="0"><tr>';
		
		for (i = 0; i<m_personaArr.length; i++)
		{
			x=i+1;
			if (m_personaArr[i][PERSONA_NAME] == g_MqRef.RESX['VIZOR_ADMIN'])
			{
				evalHTML += '<td><div class="personaLinks" id="' + x + 
						'" onclick="window.open(\'http://\'+window.location.host+\'/connectadmin/?al=1\', \'_blank\', \'height=750, width=1000, resizable=1\')"><span class="linkTooltips">'
						+ personaArr[i][PERSONA_TOOLTIP] + '</span><div class="imageDiv"><img src="' + imgDir + personaArr[i][PERSONA_IMAGE] + '" /></div><br />' 
						+ personaArr[i][PERSONA_NAME]+'</div></td>';
			}
			else
			{
				evalHTML += '<td><div class="personaLinks" id="' + x + '" onclick="document.location.href=\'javascript:void(' + m_sInstanceName + '.Login(' + x 
						+ '));\'"><span class="linkTooltips">' + personaArr[i][PERSONA_TOOLTIP] + '</span><div class="imageDiv"><img class="evalImageDivImg" src="' + imgDir + personaArr[i][PERSONA_IMAGE] 
						+ '" /></div><br />' + personaArr[i][PERSONA_NAME]+'</div></td>';
			}
		}

		
		evalHTML += '</tr></table></center>';
		if(divEvalContent)
		{
			$('#EvalContent').html(evalHTML.toString());
		}	
	}
	
	function Login(objId)
	{
		
		var i;
		var varfrmLogon = m_docHTML.Logon;
		if (objId)
		{
			for (i=1; i<=personaArr.length; i++)
			{
				if (objId == i)
				{
					varfrmLogon.UserName.value = personaArr[i-1][PERSONA_USERNAME];
					varfrmLogon.Password.value = personaArr[i-1][PERSONA_PASS];
					if(m_callerRef){
						m_callerRef.logOn();
					}
				}
			}
		}
	}

	_me.WriteMenu=WriteMenu;
	_me.Login=Login;

}